\\ Copyright 2019, 2020, 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
default(strictargs,1);
read("../vecper.gp");

\\ A302258 defined constant
f = 272115870842319/18913000000000000

print("vecper_polrev()");
v_polrev=vecper_polrev(vecper_frac_digits(f));
poldegree(denominator(v_polrev)) == 9457  || error();
denominator(v_polrev)
1-x^18912 == (1 - x + x^9456 - x^9457) * Pol(vector(9455+1,i,1))  || error();

\\ starts .014387768775 and thereafter is periodic
fixed = 14387768775;
fperiodic = f*10^12 - fixed
gfixed = x*Polrev(digits(fixed));  \\ digits 01438.. with constant term 0

\\ periodic part, as .03933802...
fperiodic == 744/18913  || error();

frac(fperiodic*(10^18912-1)) == 0    || error();

print("F");
F=272115870842319/18913000000000000;
P=F*10^12-14387768775; 
L=18912; 
poldegree(denominator(Polrev(digits(P*(10^L-1)))/(1-x^L))) == 9457  || error();


\\ period length as noted by Charles R. Greathouse
period_length = 18912;

\\ 3/7.0
\\ fperiodic=3/7
\\ period_length=6
\\ digits(floor(fperiodic * 10^period_length))

num_digits = digits(floor(fperiodic * 10^period_length));
num_digits = concat(vector(period_length-#num_digits), num_digits);  \\ leading 0s
gnum = Polrev(num_digits);
gden = 1 - x^period_length;

1/10.0 * subst(gnum,x,1/10) / subst(gden,x,1/10)
1/10.0 * (subst(gfixed,x,1/10) + 1/10^12 * subst(gnum,x,1/10) / subst(gden,x,1/10))

gperiodic = gnum/gden;    \\ digits 0393380 starting constant term 0
fperiodic == 1/10 * subst(gperiodic,x,1/10)   || error();
gf_terms(g,20)

g = gfixed + x^12*gperiodic;
poldegree(denominator(gperiodic)) == 9457  || error();
poldegree(denominator(g))         == 9457  || error();

f == 1/10 * subst(g,x,1/10)   || error();
gcd(numerator(g),denominator(g)) == 1  || error();

print("end");